
import std.stdio;
import std.format;

import edsm;
import esrc;

class Stopper : StageMachine {

    enum ulong M0_IDLE = 0;
    Signal sg0, sg1;

    this() {
        super("STOPPER");

        Stage init, idle;
        init = addStage("INIT", &stopperInitEnter);
        idle = addStage("IDLE", &stopperIdleEnter);

        init.addReflex("M0", idle);

        idle.addReflex("S0", &stopperIdleS0);
        idle.addReflex("S1", &stopperIdleS1);
    }

    void stopperInitEnter() {
        sg0 = newSignal(Signal.sigInt);
        sg1 = newSignal(Signal.sigTerm);
        msgTo(this, M0_IDLE);
    }

    void stopperIdleEnter() {
        sg0.enable();
        sg1.enable();
    }

    void _bye() {
        stopEventQueue();
    }

    void stopperIdleS0(StageMachine src, Object o) {
        _bye();
    }

    void stopperIdleS1(StageMachine src, Object o) {
        _bye();
    }
}
