
import std.stdio : writeln, writefln;
import core.stdc.stdlib: exit;
import std.conv;

import ecap, msgq, esrc, edsm, disp;
import ioctx, pool;
import rx, tx, client, stopper;

void main(string[] args) {

    if (args.length != 4) {
        writefln("Usage: %s <host> <port> <nconnections>", args[0]);
        exit(0);
    }

    string host = args[1];
    string port = args[2];
    uint nConnections = to!uint(args[3]);

    auto stopper = new Stopper();

    RxSm[] rxMachines;
    auto rxPool = new RestRoom();
    foreach (k; 0 .. nConnections) {
        auto sm = new RxSm(rxPool);
        rxMachines ~= sm;
        sm.run();
    }

    TxSm[] txMachines;
    auto txPool = new RestRoom();
    foreach (k; 0 .. nConnections) {
        auto sm = new TxSm(txPool);
        txMachines ~= sm;
        sm.run();
    }

    EchoClient[] wrkMachines;
    foreach (k; 0 .. nConnections) {
        auto sm = new EchoClient(rxPool, txPool, host, port);
        wrkMachines ~= sm;
        sm.run();
    }

//    auto stopper = new Stopper();
    stopper.run();

    writeln(" === Hello, world! === ");
    auto md = new MessageDispatcher();
    md.loop();
    writeln(" === Goodbye, world! === ");
}
