
import std.stdio: writeln;

import ecap, msgq, esrc, edsm, disp;
import ioctx, pool;
import rx, tx, listener, worker;

enum uint maxClients = 100;

void main(string[] args) {

    RxSm[] rxMachines;
    auto rxPool = new RestRoom();
    foreach (k; 0 .. maxClients) {
        auto sm = new RxSm(rxPool);
        rxMachines ~= sm;
        sm.run();
    }

    TxSm[] txMachines;
    auto txPool = new RestRoom();
    foreach (k; 0 .. maxClients) {
        auto sm = new TxSm(txPool);
        txMachines ~= sm;
        sm.run();
    }

    WorkerSm[] wrkMachines;
    auto wrkPool = new RestRoom();
    foreach (k; 0 .. maxClients) {
        auto sm = new WorkerSm(wrkPool, rxPool, txPool);
        wrkMachines ~= sm;
        sm.run();
    }

    auto reception = new Listener(wrkPool);
    reception.run();

    writeln(" === Hello, world! === ");
    auto md = new MessageDispatcher();
    md.loop();
    writeln(" === Goodbye, world! === ");
}
